/* $Id: TwenDll.cpp 1.2 1996/07/23 21:42:15 Damien Exp $ */ 

////////////////////////////////////////////////////////////////////////
//   Tweener Example : ?????                                          //
//--------------------------------------------------------------------//
//   DLL Management                                                   //
////////////////////////////////////////////////////////////////////////   

#ifndef __TWENDLL__
#include "TWENdll.h"
#endif

#ifndef __COMTWEN__
#include "COMTWEN.h"
#endif

#ifndef __TWENFAC__
#include "TWENFac.h"
#endif

#ifndef __3DCOFAIL__
#include "3DCoFail.h"
#endif

STDAPI DllInitRDCom(IShUtilities* shellUtilities) {
	InitCoFailure(shellUtilities);
	return S_OK;
	}

//------------------------------------------------------------------------
/*
 * DllGetClassObject
 *
 * This function gives a IClassFactory with the appropriate CLSID.
 * This DLL must be in the registration database as a InProcServer
 * for the correct CLSID
 *
 * Parameters:
 *  clsID           REFCLSID that identifies the class factory
 *                  desired.  Since this parameter is passed this
 *                  DLL can handle any number of objects simply
 *                  by returning different class factories here
 *                  for different CLSIDs.
 *
 *  riid            REFIID specifying the interface the caller wants
 *                  on the class object, usually IID_ClassFactory.
 *
 *  ppv             LPVOID FAR* in which to return the interface
 *                  pointer.
 *
 * Returns NOERROR on success, otherwise an error code
 */

STDAPI DllGetClassObject(REFCLSID rclsid
    , REFIID riid, LPVOID FAR* ppv) {
  if (!IsEqualCLSID(rclsid, CLSID_Tweener))
      return ResultFromScode(E_FAIL);

  //Check that we can provide the interface
  if (!IsEqualIID(riid, IID_IUnknown) && !IsEqualIID(riid, IID_IClassFactory))
      return ResultFromScode(E_NOINTERFACE);

  //Return our IClassFactory for the correct objects
  if (IsEqualCLSID(rclsid,CLSID_Tweener))
    *ppv=(LPVOID) new TweenerClassFactory();

  if (*ppv == NULL)
      return ResultFromScode(E_OUTOFMEMORY);

  //AddRef the object through any interface we return
  ((LPUNKNOWN)*ppv)->AddRef();

  return NOERROR;
  }


/*
 * DllCanUnloadNow
 *
 *  Answers if the DLL can be unload from the memory
 *
 *  This function doesn't need any parameter
 *
 *  Returns TRUE if nothing is using us, FALSE otherwise.
 */

STDAPI DllCanUnloadNow() {
  SCODE   sc;

  //Our answer is whether there are any object or locks
  sc=(0L==global_count_Obj && 0L==global_count_Lock) ? S_OK : S_FALSE;
  return ResultFromScode(sc);
  }

//------------------------------------------------------------------------
//Count number of objects and number of locks.
long       global_count_Obj  = 0;
long       global_count_Lock = 0;

